package com.ekexiu.portal.dao;

import java.sql.Connection;
import java.sql.SQLException;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.Column;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.QueryVal;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Alias;
import org.jfw.apt.orm.annotation.dao.param.Set;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;

import com.ekexiu.portal.po.OrgUser;

@DAO
public abstract class OrgUserDao {
	@Insert
	public abstract int insert(Connection con,OrgUser orgUser)throws SQLException;
	
	@UpdateWith
	@From(OrgUser.class)
	public abstract int updateEmail(Connection con,String id,@Set String email)throws SQLException;
	
	@UpdateWith
	@From(OrgUser.class)
	public abstract int updatePasswd(Connection con,String id,@Set String passwd)throws SQLException;
	
	@UpdateWith
	@From(OrgUser.class)
	public abstract int updatePw(Connection con,String id,@Set String passwd,@Alias("passwd")String key)throws SQLException;
	
	@QueryVal
	@Column(handlerClass=StringHandler.class, value = { "EMAIL" })
	@From(OrgUser.class)
	@Nullable
	public abstract String queryOrgEmail(Connection con,String id)throws SQLException;
	
	@SelectOne
	@Nullable
	public abstract OrgUser queryOne(Connection con,String id)throws SQLException;
	
	@SelectOne
	@Nullable
	public abstract OrgUser queryByEmail(Connection con,String email)throws SQLException;
}
