package com.ekexiu.portal.job;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

import org.jfw.apt.annotation.Bean;
import org.jfw.util.bean.AfterBeanFactory;
import org.jfw.util.bean.BeanFactory;
import org.jfw.util.context.JfwAppContext;

import com.ekexiu.portal.service.WeixinService;

@Bean
public class TaskJob implements AfterBeanFactory {
	private ScheduledExecutorService service;
	
	@Override
	public void handle(BeanFactory bf) throws Throwable {
	
		TaskJobEntry tje = (TaskJobEntry) bf.getBean("com_ekexiu_portal_job_TaskJobEntry");
//		UserLogTaskJobEntry ultje = (UserLogTaskJobEntry) bf.getBean("com_ekexiu_portal_job_UserLogTaskJobEntry");
		DictTaskJobEntry dtje =(DictTaskJobEntry) bf.getBean("com_ekexiu_portal_job_DictTaskJobEntry");
		final WeixinService weixin =(WeixinService)bf.getBean("com_ekexiu_portal_service_WeixinService");
		
		long delayTime = tje.getDelayTime();
		long task = getTimeMillis(tje.getTaskTime());
		long taskTime = task - System.currentTimeMillis();
		taskTime = taskTime > 0 ? taskTime : delayTime + taskTime;
		
        this.service = JfwAppContext.getScheduledExecutorService();
        // 第二个参数为首次执行的延时时间，第三个参数为定时执行的间隔时间  
		service.scheduleAtFixedRate(tje, taskTime, delayTime, TimeUnit.MILLISECONDS);
//		service.scheduleAtFixedRate(ultje, taskTime, delayTime, TimeUnit.MILLISECONDS);
		service.scheduleAtFixedRate(dtje, 1, dtje.getDelayTime(), TimeUnit.SECONDS);
		service.scheduleAtFixedRate(new Runnable() {
			@Override
			public void run() {
				weixin.refresh();
			}
		}, 0, weixin.getDelayTime(), TimeUnit.SECONDS);
	}
	private static long getTimeMillis(String time) {  
	    try {  
	        DateFormat dateFormat = new SimpleDateFormat("yy-MM-dd HH:mm:ss");  
	        DateFormat dayFormat = new SimpleDateFormat("yy-MM-dd");  
	        Date curDate = dateFormat.parse(dayFormat.format(new Date()) + " " + time);  
	        return curDate.getTime();  
	    } catch (ParseException e) {  
	        e.printStackTrace();  
	    }  
	    return 0;  
	}
	
}
